
Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -10,6 +10,7 @@
 ;; Next Author: RMS
 ;; Next Author: Simon Marshall <simon@gnu.ai.mit.edu>
 ;; Latest XEmacs Author: Ben Wing
+;; Synched to FSF 21.2 by Ben Wing.
 ;; Maintainer: XEmacs Development Team
 ;; Keywords: languages, faces
 
@@ -30,8 +31,11 @@
 ;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 ;; Boston, MA 02111-1307, USA.
 
-;;; Synched up with: FSF 19.30 except for the code to initialize the faces.
+;;; Synched up with: FSF 21.2 except for the Java keywords.
+;;; Sync sections specifically marked.
 
+;; BEGIN SYNCHED WITH FSF 21.2.
+
 ;;; Commentary:
 
 ;; Font-lock-mode is a minor mode that causes your comments to be
@@ -45,73 +49,175 @@
 ;;  displayed in `font-lock-function-name-face'.
 ;; Reserved words will be displayed in `font-lock-keyword-face'.
 ;;
+;; Regexps are used to display selected patterns in other faces.
+;;
+;; To make the text you type be fontified, use M-x font-lock-mode RET.
+;; When this minor mode is on, the faces of the current line are updated with
+;; every insertion or deletion.
+;;
+;; To turn Font Lock mode on automatically, add this to your ~/.emacs file:
+;;
+;;  (add-hook 'emacs-lisp-mode-hook 'turn-on-font-lock)
+;;
+;; Or if you want to turn Font Lock mode on in many modes:
+;;
+;;  (global-font-lock-mode t)
+;;
+;; Fontification for a particular mode may be available in a number of levels
+;; of decoration.  The higher the level, the more decoration, but the more time
+;; it takes to fontify.  See the variable `font-lock-maximum-decoration', and
+;; also the variable `font-lock-maximum-size'.  Support modes for Font Lock
+;; mode can be used to speed up Font Lock mode.  See `font-lock-support-mode'.
+
 ;; Don't let the name fool you: you can highlight things using different
 ;; colors or background stipples instead of fonts, though that is not the
 ;; default.  See the variables `font-lock-use-colors' and
 ;; `font-lock-use-fonts' for broad control over this, or see the
 ;; documentation on faces and how to change their attributes for
 ;; fine-grained control.
+
+;;; How Font Lock mode fontifies:
+
+;; When Font Lock mode is turned on in a buffer, it (a) fontifies the entire
+;; buffer and (b) installs one of its fontification functions on one of the
+;; hook variables that are run by Emacs after every buffer change (i.e., an
+;; insertion or deletion).  Fontification means the replacement of `face' text
+;; properties in a given region; Emacs displays text with these `face' text
+;; properties appropriately.
+;;
+;; Fontification normally involves syntactic (i.e., strings and comments) and
+;; regexp (i.e., keywords and everything else) passes.  There are actually
+;; three passes; (a) the syntactic keyword pass, (b) the syntactic pass and (c)
+;; the keyword pass.  Confused?
+;;
+;; The syntactic keyword pass places `syntax-table' text properties in the
+;; buffer according to the variable `font-lock-syntactic-keywords'.  It is
+;; necessary because Emacs' syntax table is not powerful enough to describe all
+;; the different syntactic constructs required by the sort of people who decide
+;; that a single quote can be syntactic or not depending on the time of day.
+;; (What sort of person could decide to overload the meaning of a quote?)
+;; Obviously the syntactic keyword pass must occur before the syntactic pass.
+;;
+;; The syntactic pass places `face' text properties in the buffer according to
+;; syntactic context, i.e., according to the buffer's syntax table and buffer
+;; text's `syntax-table' text properties.  It involves using a syntax parsing
+;; function to determine the context of different parts of a region of text.  A
+;; syntax parsing function is necessary because generally strings and/or
+;; comments can span lines, and so the context of a given region is not
+;; necessarily apparent from the content of that region.  Because the keyword
+;; pass only works within a given region, it is not generally appropriate for
+;; syntactic fontification.  This is the first fontification pass that makes
+;; changes visible to the user; it fontifies strings and comments.
+;;
+;; The keyword pass places `face' text properties in the buffer according to
+;; the variable `font-lock-keywords'.  It involves searching for given regexps
+;; (or calling given search functions) within the given region.  This is the
+;; second fontification pass that makes changes visible to the user; it
+;; fontifies language reserved words, etc.
+;;
+;; Oh, and the answer is, "Yes, obviously just about everything should be done
+;; in a single syntactic pass, but the only syntactic parser available
+;; understands only strings and comments."  Perhaps one day someone will write
+;; some syntactic parsers for common languages and a son-of-font-lock.el could
+;; use them rather then relying so heavily on the keyword (regexp) pass.
+
+;;; How Font Lock mode supports modes or is supported by modes:
+
+;; Modes that support Font Lock mode do so by defining one or more variables
+;; whose values specify the fontification.  Font Lock mode knows of these
+;; variable names from (a) the buffer local variable `font-lock-defaults', if
+;; non-nil, or (b) the global variable `font-lock-defaults-alist', if the major
+;; mode has an entry.  (Font Lock mode is set up via (a) where a mode's
+;; patterns are distributed with the mode's package library, and (b) where a
+;; mode's patterns are distributed with font-lock.el itself.  An example of (a)
+;; is Pascal mode, an example of (b) is Lisp mode.  Normally, the mechanism is
+;; (a); (b) is used where it is not clear which package library should contain
+;; the pattern definitions.)  Font Lock mode chooses which variable to use for
+;; fontification based on `font-lock-maximum-decoration'.
+;;
+;; Font Lock mode fontification behaviour can be modified in a number of ways.
+;; See the below comments and the comments distributed throughout this file.
+
+;;; Constructing patterns:
+
+;; See the documentation for the variable `font-lock-keywords'.
+;;
+;; Efficient regexps for use as MATCHERs for `font-lock-keywords' and
+;; `font-lock-syntactic-keywords' can be generated via the function
+;; `regexp-opt'.
+
+;;; Adding patterns for modes that already support Font Lock:
+
+;; Though Font Lock highlighting patterns already exist for many modes, it's
+;; likely there's something that you want fontified that currently isn't, even
+;; at the maximum fontification level.  You can add highlighting patterns via
+;; `font-lock-add-keywords'.  For example, say in some C
+;; header file you #define the token `and' to expand to `&&', etc., to make
+;; your C code almost readable.  In your ~/.emacs there could be:
+;;
+;;  (font-lock-add-keywords 'c-mode '("\\<\\(and\\|or\\|not\\)\\>"))
+;;
+;; Some modes provide specific ways to modify patterns based on the values of
+;; other variables.  For example, additional C types can be specified via the
+;; variable `c-font-lock-extra-types'.
+
+;;; Adding patterns for modes that do not support Font Lock:
+
+;; Not all modes support Font Lock mode.  If you (as a user of the mode) add
+;; patterns for a new mode, you must define in your ~/.emacs a variable or
+;; variables that specify regexp fontification.  Then, you should indicate to
+;; Font Lock mode, via the mode hook setting `font-lock-defaults', exactly what
+;; support is required.  For example, say Foo mode should have the following
+;; regexps fontified case-sensitively, and comments and strings should not be
+;; fontified automagically.  In your ~/.emacs there could be:
+;;
+;;  (defvar foo-font-lock-keywords
+;;    '(("\\<\\(one\\|two\\|three\\)\\>" . font-lock-keyword-face)
+;;      ("\\<\\(four\\|five\\|six\\)\\>" . font-lock-type-face))
+;;    "Default expressions to highlight in Foo mode.")
+;;
+;;  (add-hook 'foo-mode-hook
+;;   (function (lambda ()
+;;               (make-local-variable 'font-lock-defaults)
+;;               (setq font-lock-defaults '(foo-font-lock-keywords t)))))
+
+;;; Adding Font Lock support for modes:
+
+;; Of course, it would be better that the mode already supports Font Lock mode.
+;; The package author would do something similar to above.  The mode must
+;; define at the top-level a variable or variables that specify regexp
+;; fontification.  Then, the mode command should indicate to Font Lock mode,
+;; via `font-lock-defaults', exactly what support is required.  For example,
+;; say Bar mode should have the following regexps fontified case-insensitively,
+;; and comments and strings should be fontified automagically.  In bar.el there
+;; could be:
+;;
+;;  (defvar bar-font-lock-keywords
+;;    '(("\\<\\(uno\\|due\\|tre\\)\\>" . font-lock-keyword-face)
+;;      ("\\<\\(quattro\\|cinque\\|sei\\)\\>" . font-lock-type-face))
+;;    "Default expressions to highlight in Bar mode.")
 ;;
-;; To make the text you type be fontified, use M-x font-lock-mode.  When
-;; this minor mode is on, the fonts of the current line will be updated
-;; with every insertion or deletion.
-;;
-;; By default, font-lock will automatically put newly loaded files
-;; into font-lock-mode if it knows about the file's mode.  See the
-;; variables `font-lock-auto-fontify', `font-lock-mode-enable-list',
-;; and `font-lock-mode-disable-list' for control over this.
-;;
-;; The `font-lock-keywords' variable defines other patterns to highlight.
-;; The default font-lock-mode-hook sets it to the value of the variables
-;; lisp-font-lock-keywords, c-font-lock-keywords, etc, as appropriate.
-;; The easiest way to change the highlighting patterns is to change the
-;; values of c-font-lock-keywords and related variables.  See the doc
-;; string of the variable `font-lock-keywords' for the appropriate syntax.
-;;
-;; The default value for `lisp-font-lock-keywords' is the value of the variable
-;; `lisp-font-lock-keywords-1'.  You may like `lisp-font-lock-keywords-2' 
-;; better; it highlights many more words, but is slower and makes your buffers
-;; be very visually noisy.
-;;
-;; The same is true of `c-font-lock-keywords-1' and `c-font-lock-keywords-2';
-;; the former is subdued, the latter is loud.
-;;
-;; You can make font-lock default to the gaudier variety of keyword
-;; highlighting by setting the variable `font-lock-maximum-decoration'
-;; before loading font-lock, or by calling the functions
-;; `font-lock-use-default-maximal-decoration' or
-;; `font-lock-use-default-minimal-decoration'.
-;;
-;; On a Sparc10, the initial fontification takes about 6 seconds for a typical
-;; 140k file of C code, using the default configuration.  The actual speed
-;; depends heavily on the type of code in the file, and how many non-syntactic
-;; patterns match; for example, Xlib.h takes 23 seconds for 101k, because many
-;; patterns match in it.  You can speed this up substantially by removing some
-;; of the patterns that are highlighted by default.  Fontifying lisp code is
-;; significantly faster, because lisp has a more regular syntax than C, so the
-;; regular expressions don't have to be as complicated.
+;; and within `bar-mode' there could be:
 ;;
+;;  (make-local-variable 'font-lock-defaults)
+;;  (setq font-lock-defaults '(bar-font-lock-keywords nil t))
+
+;;
 ;; It's called font-lock-mode here because on the Lispms it was called
 ;; "Electric Font Lock Mode."  It was called that because there was an older
 ;; mode called "Electric Caps Lock Mode" which had the function of causing all
 ;; of your source code to be in upper case except for strings and comments,
 ;; without you having to blip the caps lock key by hand all the time (thus the
-;; "electric", as in `electric-c-brace'.)
+;; "electric", as in `electric-c-brace').
 
-;; See also the related packages `fast-lock' and `lazy-lock'.  Both
-;; attempt to speed up the initial fontification.  `fast-lock' saves
-;; the fontification info when you exit Emacs and reloads it next time
-;; you load the file, so that the file doesn't have to be fontified
-;; again.  `lazy-lock' does "lazy" fontification -- i.e. it only
-;; fontifies the text as it becomes visible rather than fontifying
-;; the whole file when it's first loaded in.
-
-;; Further comments from the FSF:
-
-;; Nasty regexps of the form "bar\\(\\|lo\\)\\|f\\(oo\\|u\\(\\|bar\\)\\)\\|lo"
-;; are made thusly: (regexp-opt '("foo" "fu" "fubar" "bar" "barlo" "lo")) for
-;; efficiency.
-
+;; See also the related packages `fast-lock', `lazy-lock' and `lazy-shot'.
+;; All attempt to speed up the initial fontification.  `fast-lock' saves
+;; the fontification info when you exit Emacs and reloads it next time you
+;; load the file, so that the file doesn't have to be fontified again.
+;; `lazy-lock' does "lazy" fontification -- i.e. it only fontifies the text
+;; as it becomes visible rather than fontifying the whole file when it's
+;; first loaded in.
+
 ;; What is fontification for?  You might say, "It's to make my code look nice."
 ;; I think it should be for adding information in the form of cues.  These cues
 ;; should provide you with enough information to both (a) distinguish between
@@ -121,15 +227,18 @@
 ;; doesn't work.  Or maybe it allows you to think less and drift off to sleep.
 ;;
 ;; So, here are my opinions/advice/guidelines:
-;; 
+;;
+;; - Highlight conceptual objects, such as function and variable names, and
+;;   different objects types differently, i.e., (a) and (b) above, highlight
+;;   function names differently to variable names.
+;; - Keep the faces distinct from each other as far as possible.
+;;   i.e., (a) above.
 ;; - Use the same face for the same conceptual object, across all modes.
 ;;   i.e., (b) above, all modes that have items that can be thought of as, say,
 ;;   keywords, should be highlighted with the same face, etc.
-;; - Keep the faces distinct from each other as far as possible.
-;;   i.e., (a) above.
 ;; - Make the face attributes fit the concept as far as possible.
-;;   i.e., function names might be a bold color such as blue, comments might
-;;   be a bright color such as red, character strings might be brown, because,
+;;   i.e., function names might be a bold colour such as blue, comments might
+;;   be a bright colour such as red, character strings might be brown, because,
 ;;   err, strings are brown (that was not the reason, please believe me).
 ;; - Don't use a non-nil OVERRIDE unless you have a good reason.
 ;;   Only use OVERRIDE for special things that are easy to define, such as the
@@ -140,10 +249,6 @@
 
 ;;; Code:
 
-(require 'fontl-hooks)
-
-;;;;;;;;;;;;;;;;;;;;;;      user variables       ;;;;;;;;;;;;;;;;;;;;;;
-
 (defgroup font-lock nil
   "Decorate source files with fonts/colors based on syntax.
 Font-lock-mode is a minor mode that causes your comments to be
@@ -157,19 +262,49 @@
  in `font-lock-function-name-face'.
 Reserved words will be displayed in `font-lock-keyword-face'.
 Preprocessor conditionals will be displayed in `font-lock-preprocessor-face'."
+:link '(custom-manual "(emacs)Font Lock")
+:link '(custom-manual "(elisp)Font Lock Mode")
   :group 'languages)
 
+;; Called font-lock-highlighting-faces in FSF 21.2.
 (defgroup font-lock-faces nil
-  "Faces used by the font-lock package."
+  "Faces for highlighting text using the font-lock package."
+:prefix "font-lock-"
   :group 'font-lock
   :group 'faces)
 
+(defgroup font-lock-extra-types nil
+  "Extra mode-specific type names for highlighting declarations."
+:group 'font-lock)
+
+;; Define support mode groups here to impose `font-lock' group order.
+(defgroup fast-lock nil
+  "Font Lock support mode to cache fontification."
+:link '(custom-manual "(emacs)Support Modes")
+:load 'fast-lock
+:group 'font-lock)
 
-(defcustom font-lock-verbose t
-  "*If non-nil, means show status messages when fontifying.
-See also `font-lock-message-threshold'."
-:type 'boolean
+(defgroup lazy-lock nil
+  "Font Lock support mode to fontify lazily."
+:link '(custom-manual "(emacs)Support Modes")
+:load 'lazy-lock
+:group 'font-lock)
+
+(defgroup lazy-shot nil
+  "Font Lock support mode to fontify with lazy-shot."
+:link '(custom-manual "(emacs)Support Modes")
+:version "21.1"
+:load 'lazy-shot
+:group 'font-lock)
+
+(defgroup jit-lock nil
+  "Font Lock support mode to fontify just-in-time."
+:link '(custom-manual "(emacs)Support Modes")
+:version "21.1"
+:load 'jit-lock
   :group 'font-lock)
+
+;; User variables.
 
 (defcustom font-lock-message-threshold 6000
   "*Minimum size of region being fontified for status messages to appear.
@@ -187,28 +322,6 @@
   :group 'font-lock)
 
 ;;;###autoload
-(defcustom font-lock-auto-fontify t
-  "*Whether font-lock should automatically fontify files as they're loaded.
-This will only happen if font-lock has fontifying keywords for the major
-mode of the file.  You can get finer-grained control over auto-fontification
-by using this variable in combination with `font-lock-mode-enable-list' or
-`font-lock-mode-disable-list'."
-:type 'boolean
-:group 'font-lock)
-
-;;;###autoload
-(defcustom font-lock-mode-enable-list nil
-  "*List of modes to auto-fontify, if `font-lock-auto-fontify' is nil."
-:type '(repeat (symbol :tag "Mode"))
-:group 'font-lock)
-
-;;;###autoload
-(defcustom font-lock-mode-disable-list nil
-  "*List of modes not to auto-fontify, if `font-lock-auto-fontify' is t."
-:type '(repeat (symbol :tag "Mode"))
-:group 'font-lock)
-
-;;;###autoload
 (defcustom font-lock-use-colors '(color)
   "*Specification for when Font Lock will set up color defaults.
 Normally this should be '(color), meaning that Font Lock will set up
@@ -261,16 +374,39 @@
   :group 'font-lock)
 
 ;;;###autoload
+(defcustom font-lock-maximum-size 256000
+  "*Maximum size of a buffer for buffer fontification.
+Only buffers less than this can be fontified when Font Lock mode is turned on.
+If nil, means size is irrelevant.
+If a list, each element should be a cons pair of the form (MAJOR-MODE . SIZE),
+where MAJOR-MODE is a symbol or t (meaning the default).  For example:
+ ((c-mode . 256000) (c++-mode . 256000) (rmail-mode . 1048576))
+means that the maximum size is 250K for buffers in C or C++ modes, one megabyte
+for buffers in Rmail mode, and size is irrelevant otherwise."
+:type '(choice (const :tag "none" nil)
+		 (integer :tag "size")
+		 (repeat :menu-tag "mode specific" :tag "mode specific"
+			 :value ((t . nil))
+			 (cons :tag "Instance"
+			       (radio :tag "Mode"
+				      (const :tag "all" t)
+				      (symbol :tag "name"))
+			       (radio :tag "Size"
+				      (const :tag "none" nil)
+				      (integer :tag "size")))))
+:group 'font-lock)
+
+;;;###autoload
 (defcustom font-lock-maximum-decoration t
-  "*If non-nil, the maximum decoration level for fontifying.
-If nil, use the minimum decoration (equivalent to level 0).
+  "*Maximum decoration level for fontification.
+If nil, use the default decoration (typically the minimum available).
 If t, use the maximum decoration available.
 If a number, use that level of decoration (or if not available the maximum).
 If a list, each element should be a cons pair of the form (MAJOR-MODE . LEVEL),
 where MAJOR-MODE is a symbol or t (meaning the default).  For example:
- ((c++-mode . 2) (c-mode . t) (t . 1))
-means use level 2 decoration for buffers in `c++-mode', the maximum decoration
-available for buffers in `c-mode', and level 1 decoration otherwise."
+ ((c-mode . t) (c++-mode . 2) (t . 1))
+means use the maximum decoration available for buffers in C mode, level 2
+decoration for buffers in C++ mode, and level 1 decoration otherwise."
   :type '(choice (const :tag "default" nil)
 		 (const :tag "maximum" t)
 		 (integer :tag "level" 1)
@@ -286,31 +422,12 @@
 				      (integer :tag "level" 1)))))
   :group 'font-lock)
 
-;;;###autoload
-(define-obsolete-variable-alias 'font-lock-use-maximal-decoration
-  'font-lock-maximum-decoration)
-
-;;;###autoload
-(defcustom font-lock-maximum-size (* 250 1024)
-  "*If non-nil, the maximum size for buffers for fontifying.
-Only buffers less than this can be fontified when Font Lock mode is turned on.
-If nil, means size is irrelevant.
-If a list, each element should be a cons pair of the form (MAJOR-MODE . SIZE),
-where MAJOR-MODE is a symbol or t (meaning the default).  For example:
- ((c++-mode . 256000) (c-mode . 256000) (rmail-mode . 1048576))
-means that the maximum size is 250K for buffers in `c++-mode' or `c-mode', one
-megabyte for buffers in `rmail-mode', and size is irrelevant otherwise."
-:type '(choice (const :tag "none" nil)
-		 (integer :tag "size")
-		 (repeat :menu-tag "mode specific" :tag "mode specific"
-			 :value ((t . nil))
-			 (cons :tag "Instance"
-			       (radio :tag "Mode"
-				      (const :tag "all" t)
-				      (symbol :tag "name"))
-			       (radio :tag "Size"
-				      (const :tag "none" nil)
-				      (integer :tag "size")))))
+(defcustom font-lock-verbose 0
+  "*If non-nil, means show status messages for buffer fontification.
+If a number, only buffers greater than this size have fontification messages."
+:type '(choice (const :tag "never" nil)
+		 (other :tag "always" t)
+		 (integer :tag "size"))
   :group 'font-lock)
 
 ;;;###autoload
@@ -327,6 +444,90 @@
   :type '(choice string
 		 (const :tag "none" nil))
   :group 'font-lock)
+
+
+;;; Initialization of faces.
+
+;; #### barf gag retch.  Horrid FSF lossage that we need to
+;; keep around for compatibility with font-lock-keywords that
+;; forget to properly quote their faces.  I tried just let-binding
+;; them when we eval the face expression, but that fails because
+;; some	files actually use the variables directly in their init code
+;; without quoting them. --ben
+
+;; FSF 21.2 says:
+
+;; Originally these variable values were face names such as `bold' etc.
+;; Now we create our own faces, but we keep these variables for compatibility
+;; and they give users another mechanism for changing face appearance.
+;; We now allow a FACENAME in `font-lock-keywords' to be any expression that
+;; returns a face.  So the easiest thing is to continue using these variables,
+;; rather than sometimes evaling FACENAME and sometimes not.  sm.
+(defvar font-lock-comment-face 'font-lock-comment-face
+  "Face name to use for comments.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-string-face 'font-lock-string-face
+  "Face name to use for strings.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-doc-string-face 'font-lock-doc-string-face
+  "Face name to use for documentation.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+;; GNU compatibility
+(define-compatible-variable-alias
+  'font-lock-doc-face 'font-lock-doc-string-face)
+(defvar font-lock-keyword-face 'font-lock-keyword-face
+  "Face name to use for keywords.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-builtin-face 'font-lock-builtin-face
+  "Face name to use for builtins.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-function-name-face 'font-lock-function-name-face
+  "Face name to use for function names.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-variable-name-face 'font-lock-variable-name-face
+  "Face name to use for variable names.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-type-face 'font-lock-type-face
+  "Face name to use for type and class names.  This variable should not be set.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-constant-face 'font-lock-constant-face
+  "Face name to use for constants and label names.  Do not set this variable.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-warning-face		'font-lock-warning-face
+  "Face name to use for things that should stand out.  Do not set this variable.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-preprocessor-face 'font-lock-preprocessor-face
+  "Face name to use for processor declarations.  Do not set this variable.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+(defvar font-lock-reference-face	'font-lock-constant-face
+  "This variable is obsolete.  Use `font-lock-constant-face'.
+Do not set this variable.
+It is present only for horrid FSF compatibility reasons.
+The corresponding face should be set using `edit-faces' or the
+`set-face-*' functions.")
+
 
 ;; Fontification variables:
 
@@ -347,15 +548,25 @@
                       | A variable containing a regexp to search for.
                       | A function to call to make the search.
                         It is called with one arg, the limit of the search,
-                        and should leave MATCH results in the XEmacs global
-                        match data.
+                        and should return non-nil if it succeeds and leave
+                        MATCH results in the XEmacs global match data.
+                        MATCHER regexps can be generated via the function
+                        `regexp-opt'.
 
  MATCH              :== An integer match subexpression number from MATCHER.
 
  FACE-FORM           :== The symbol naming a defined face.
-                      | Expression whos value is the face name to use.  If you
+                      | Expression whose value is the face name to use.  If you
                         want FACE-FORM to be a symbol that evaluates to a face,
-                        use a form like \"(progn sym)\".
+                        use a form like \"(progn sym)\".  Face default
+                        attributes can be modified via \\[customize].  Instead
+                        of a face, FACE-FORM can evaluate to a property list of
+                        the form (face VAL1 PROP2 VAL2 PROP3 VAL3 ...) in which
+                        case all the listed text-properties will be set rather
+                        than just `face'.  In such a case, you will most likely
+                        want to put those properties in
+                        `font-lock-extra-managed-props' or to override
+                        `font-lock-unfontify-region-function'.
 
  HIGHLIGHT          :== MATCH-HIGHLIGHT
                       | MATCH-ANCHORED
